#import <AppKit/AppKit.h>

#import "CPUInformationCenter.h"
#import "CPULoadView.h"
#import "XloadPreferences.h"

@interface CPUController : NSObject
{
    id window_;
    
    XloadPreferences	* preferences_;
    
    CPULoadView 	** cpuViewArray_;
    NSTextField 	** cpuNameArray_;
    
    unsigned long	numberOfCPU_;
    
    CPUInformationCenter * informationCenter_;

    NSTimer * timer_;
    
    int	oldDisplayName_;
    
    // Dock display Management
    
    NSImage		* applicationIcon;
    NSImage		* realApplicationIcon;
}

- (id) window;

- (unsigned long) numberOfCPU;

- (NSImage *) applicationIcon;

- (void) updateTimerInterval;

- (void) updateLoad:(id) sender;

- (void) showSettings: (id) inSender;

- (void) showHideInDock: (id) inSender;

- (void) setWindowPositionAndSize;

- (void) setViewPosition;

- (void)drawDockIcon;

- (void) setVisualizationMode:(int) inMode;

@end
