/* CPUInformationCenter.m created by stephane on Wed 16-Aug-2000 */

#import "CPUInformationCenter.h"
#import "CPUInformation.h"

#include <mach/mach.h>
#include <mach/mach_error.h>

@implementation CPUInformationCenter

- (id) init
{
    kern_return_t error;
    processor_info_array_t tArray;
    natural_t tProcNumber;
    CPUInformation * tCPUInformation;
    natural_t i;
    mach_msg_type_number_t tProcessor_infoCnt;
    error = host_processor_info(mach_host_self(),PROCESSOR_BASIC_INFO,&tProcNumber,&tArray,&tProcessor_infoCnt);

    if (error == KERN_SUCCESS)
    {
    
        CPUNumber_=tProcNumber;

        CPUCluster_=[[NSMutableArray alloc]initWithCapacity:CPUNumber_];
    
        for(i=0;i<tProcNumber;i++)
        {
            tCPUInformation=[[CPUInformation alloc]initWithCPU:
            ((processor_basic_info_data_t *) tArray)[i] CPUNumber:i];
            [CPUCluster_ addObject:tCPUInformation];
        }
        
        vm_deallocate( mach_task_self(), (vm_address_t)tArray, tProcessor_infoCnt );
    }
    else
    {
        mach_error("host_processor_info", error);
    }
    return self;
}

- (void) dealloc
{
    [CPUCluster_ release];
    
    [super dealloc];
}

- (unsigned long) numberOfCPU
{
    return CPUNumber_;
}

- (unsigned long *) loadOfCPUNumber:(unsigned long) inIndex
{
    return [[CPUCluster_ objectAtIndex:inIndex] CPULoad];
}

- (NSString *) nameOfCPUNumber:(unsigned long) inIndex
{
    return [[CPUCluster_ objectAtIndex:inIndex] CPUName];
}

- (unsigned long) frequencyOfCPUNumber:(unsigned long) inIndex
{
    return [[CPUCluster_ objectAtIndex:inIndex] CPUFrequency];
}

@end
