//
//  CPULoadView.h
//  Xload
//
//  Created by stephane on Thu Aug 24 2000.
//  Copyright (c) 2000 Stphane Sudre. All rights reserved.
//

#import <AppKit/AppKit.h>
#import <ApplicationServices/ApplicationServices.h>

#define HISTORY_SIZE	10

typedef struct
{
    long user;
    long kernel;
    long idle;
    long nice;
} CPUHistorySample;

@interface CPULoadView : NSView
{
    // Datas
    
    unsigned long	samplesNumber_;
    unsigned long	samplesPresentNumber_;
    unsigned long 	sampleIndex_;
    float 	*	samples_;
    
    NSTrackingRectTag	trackingTag_;
    BOOL				showPercentage_;
    
    CPUHistorySample 	history_[HISTORY_SIZE]; 
    long 		totalUser_;
    long 		totalKernel_;
    long 		totalIdle_;
    long 		totalNice_;
    long		totalFull_;
    long		historyIndex_;
    
    // Design
    
    BOOL		fill_;
    BOOL		grid_;
    NSColor	*	backColor_;
    NSColor	*	foreColor_;
}

- (void) addSample:(unsigned long *) inLoad;
- (void) drawRect:(NSRect) aRect;
- (void) drawVectorInRect:(NSRect) inRect;
- (BOOL) fill;
- (void) setFill:(BOOL) inFill;

- (NSColor *) backColor;
- (NSColor *) foreColor;

- (void) invertFill: (id) inSender;
- (void) invertGrid: (id) inSender;
- (void) backgroundColorSetUp: (id) inSender;
- (void) foregroundColorSetUp: (id) inSender;
- (void) setBackgroundColor: (id) inSender;
- (void) setForegroundColor: (id) inSender;
- (NSTrackingRectTag) trackingTag;
- (void) setTrackingTag:(NSTrackingRectTag) inTrackingTag;

- (void) loadViewSettings:(int) inIndex;
- (void) saveViewSettings:(int) inIndex;

- (void)mouseEntered:(NSEvent *)theEvent;
- (void)mouseExited:(NSEvent *)theEvent;

+ (NSString *)colorToString:(NSColor *)theColor;
+ (NSColor *)stringToColor:(NSString *)theString;




@end
