//
//  XloadPreferences.h
//  XLoad
//
//  Created by stephane on Mon Oct 02 2000.
//  Copyright (c) 2000 Stphane Sudre. All rights reserved.
//

#import <AppKit/AppKit.h>

enum {
    kUpperLeftCorner,
    kUpperRightCorner,
    kLowerRightCorner,
    kLowerLeftCorner,
    kCustom
};

enum {
    kHorizontal,
    kVertical
};

@interface XloadPreferences : NSObject {

    int			positionKind_;
    NSRect		position_;
    int			hideCPUName_;
    int			dock_;
    int			textDock_;

    int			alignment_;
    NSTimeInterval	samplePeriod_;
    
    // Interface
    
	IBOutlet id IBwindow_;
	
    IBOutlet id IBposition_;
    IBOutlet id IBorientation_;
    IBOutlet id IBsamplePeriod_;
    IBOutlet id IBcpuName_;
    IBOutlet id IBdock_;
    IBOutlet id IBtextDock_;
    
    id CPUcontroller_;
}

- (int) dock;
- (void) setDock:(int) inDock;

- (int) textDock;
- (void) setTextDock:(int) inTextDock;

- (int) hideCPUName;
- (void) setHideCPUName:(int) inHideCPUName;

- (int) positionKind;
- (void) setPositionKind:(int) inPositionKind;

- (NSRect) position;
- (void) setPosition:(NSRect) inPosition;

- (int) alignment;
- (void) setAlignment:(int) inAlignment;

- (NSTimeInterval) samplePeriod;
- (void) setSamplePeriod:(NSTimeInterval) inSamplePeriod;

- (void) load;
- (void) save;

- (void) setDefault;

- (void) showSettings:(id) sender;
- (void) setSettings:(id) sender;
- (void) updateUI;

@end
